Subject: Re: bug#29349: [Patch] Bug 29349: read_key_sequence is only partially recursive. This is a bug.

From: Eli Zaretskii <[email-masked]>
Date: Sun, 19 Nov 2017 19:01:09 +0200

> Date: Sun, 19 Nov 2017 15:59:08 +0000
> From: Alan Mackenzie <[email-masked]>
> 
> > > In a Linux tty using the GPM mouse package, doing read_key_sequence (the
> > > C function in keyboard.c), when a menu action is activated,
> > > read_key_sequence calls itself recursively to handle all the mouse
> > > manipulation.
> 
> > > Unfortunately, the variable raw_keybuf_count is initialised to 0 in
> > > r_k_s.  This includes in the recursive call.  This variable indexes the
> > > global buffer raw_keybuf, which accumulates the raw events which make up
> > > the key sequence.
> 
> > > The result of this is that the events in the recursive call overwrite
> > > the stored events of the outer r_k_s call, leaving a mess.
> 
> > > r_k_s is static in keyboard.c and is called from three functions:
> > > command_loop_1, read_menu_command (the one that gives the trouble), and
> > > read_key_sequence_vs.
> 
> > > So I propose as a solution that raw_keybuf_count be initialised to zero
> > > in two of these three functions, but not in read_menu_command (and no
> > > longer in read_key_sequence).  I've tried this, and it seems to work.
> > > It has the disadvantage of being ugly, and it makes read_menu_command
> > > only callable as a subfunction of r_k_s.
> 
> > > Has anybody any thoughts on this?
> 
> > Here is how I propose to solve this:

Can you please show a recipe where the current code misbehaves?  I've
re-read the thread, and found myself confused wrt the practical
implications of the problem you describe.

Thanks.